/*
Copyright (C) 2004, 2005 Brian Victor Fernandes

This file is part of SuperSify.

SuperSify is a simple console based client which you can use to log into your Sify Broadband account. 
Currently, it exists only for Win32 systems.
SuperSify is a standalone client and does not require Sify's Client to work. 

SuperSify is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with XMMS mp3cue; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

SuperSify: http://broadbandforum.in/sify/supersify
Email: infernalproteus@gmail.com
*/
#include <iostream>
#include <map>
using namespace std;

class CmdlineParser {
private:
	typedef map<char, string> CSMAP;
	typedef map<char, bool> BMAP;
	CSMAP params;
	BMAP bParams;
	
public:
	
	CmdlineParser(int argc, char *argv[]) {

		for(int i=1;i<argc;i++) {
			if(argv[i][0] == '-') {
				if(strlen(argv[i]) > 1) {
					if(i+1 < argc && argv[i+1][0] != '-') {
						params.insert(CSMAP::value_type(argv[i][1], string(argv[i+1])));
						bParams.insert(BMAP::value_type(argv[i][1], true));
						i++;
					}
					else {
						params.insert(CSMAP::value_type(argv[i][1], string("")));
						bParams.insert(BMAP::value_type(argv[i][1], true));
					}					
				}
			}
		}

	}

	string getOptionValue(char opt)
	{
		return params[opt];
	}
	
	bool getBooleanValue(char opt) {		
		return bParams[opt];
	}

};