/*
Copyright (C) 2004, 2005 Brian Victor Fernandes

This file is part of SuperSify.

SuperSify is a simple console based client which you can use to log into your Sify Broadband account. 
Currently, it exists only for Win32 systems.
SuperSify is a standalone client and does not require Sify's Client to work. 

SuperSify is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with XMMS mp3cue; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

SuperSify: http://broadbandforum.in/sify/supersify
Email: infernalproteus@gmail.com
*/
// HTTPUtils.cpp: implementation of the HTTPUtils class.
//
//////////////////////////////////////////////////////////////////////

#include "HTTPUtils.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HTTPUtils::HTTPUtils()
{
	
}

HTTPUtils::~HTTPUtils()
{
}

void HTTPUtils::parseURL(const char *url, string *ip, int *port, string *path) {
	string uStr(url);
	int ipStart = uStr.find_first_of("//") + 2;
	int portStart = uStr.find(':', ipStart) + 1;
	int pathStart = uStr.find('/', portStart);
	
	*ip = uStr.substr(ipStart, portStart-ipStart-1);	
	*port = atoi(uStr.substr(portStart, pathStart-portStart).c_str());
	*path = uStr.substr(pathStart);
}

string HTTPUtils::postData(string data, const char *url) 
{
	cout << "URL being used is: " << url << endl;
	string uStr(url);
	string ip, path;
	int port;
	parseURL(url, &ip, &port, &path);	
	
	//cout << endl << "IP :" << ip  << " Port:" << port << " path:" << path;

	int postSocket = socket(AF_INET, SOCK_STREAM, 0);
	if(postSocket == -1) {
		cout << "SuperSify: Error creating socket" << endl;
		return "";
	}

	struct sockaddr_in sifyAddress;
	sifyAddress.sin_family = AF_INET;
	sifyAddress.sin_port = htons(port);
	sifyAddress.sin_addr.s_addr = inet_addr(ip.c_str());
	memset(&(sifyAddress.sin_zero), 0, 8); 

	if(connect(postSocket, (sockaddr *)&sifyAddress, sizeof(sifyAddress)) == -1) {
		cout << "SuperSify: Error connecting to Sify server" << endl;
		return "";
	}

	int tLen = data.length();
	char len[4];
	itoa(data.length(), len, 10);
	string dlen(len);
	string request = string("POST ") + path + string(" HTTP/1.0\r\n") + string("Content-Type: application/x-www-form-urlencoded\r\nContent-Length: ") + dlen + string("\r\n\r\n") + data + string("\r\n\r\n");

	//cout << endl << "REquest is:" << request.data() <<"END";
	sendall(postSocket, request.c_str(), request.length());

	string rData = recvXML(postSocket);
	closesocket(postSocket);

	return rData;
}

string HTTPUtils::getData(const char *url) 
{	
	int getSocket = socket(AF_INET, SOCK_STREAM, 0);
	if(getSocket == -1) {
		cout << "SuperSify: Error creating socket " << endl;
		return "";
	}
	
	struct sockaddr_in sifyAddress;
	sifyAddress.sin_family = AF_INET;
	sifyAddress.sin_port = htons(8090);
	sifyAddress.sin_addr.s_addr = inet_addr(url);
	memset(&(sifyAddress.sin_zero), 0, 8); 

	if(connect(getSocket, (sockaddr *)&sifyAddress, sizeof(sifyAddress)) == -1) {
		cout << "SuperSify: Error connecting to Sify server" << endl;
		return "";
	}
	else cout << "Connection to Sify server established " << endl;

	//send http request
	const char *request = "GET / HTTP/1.0\r\nUser-Agent: BBClient\r\n\r\n";
	sendall(getSocket, request, strlen(request));

	string rData = recvXML(getSocket);
	closesocket(getSocket);
	return rData;

}

string HTTPUtils::recvXML(int socket) 
{
	string recvString;
	int rBytes;
	do {
		char buf[500];
		rBytes = recv(socket, buf, 500, 0);
		if(rBytes == -1) {
			cout << "SuperSify: Receive error" << endl;
			return "";
		}
		if(rBytes)
			recvString.append(buf, rBytes);
	} while(rBytes);


	int pos = recvString.find_first_of("\r\n\r\n");
	pos = recvString.find("\r\n\r\n",pos+4);
	pos = recvString.find('<',pos);

	if(pos < 0) {
		cout << "SuperSify: Receive data format error" << endl;
		return "";
	}

	return recvString.substr(pos);

}

int HTTPUtils::sendall(SOCKET sock, const char *what, int len) 
{
	while(len) {
		int n = send(sock, what, len, 0);
		if(n == -1) return -1;
		len -= n;
		what += n;
	}
	return 0;
}



