/*
Copyright (C) 2004, 2005 Brian Victor Fernandes

This file is part of SuperSify.

SuperSify is a simple console based client which you can use to log into your Sify Broadband account. 
Currently, it exists only for Win32 systems.
SuperSify is a standalone client and does not require Sify's Client to work. 

SuperSify is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with XMMS mp3cue; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

SuperSify: http://broadbandforum.in/sify/supersify
Email: infernalproteus@gmail.com
*/
#include "xmldata.h"
#include "HTTPUtils.h"
#include <windows.h>
#include <process.h>
#include <winsock.h>
#include <iostream>
#include <string>
using namespace std;



	
class Heartbeat {

private:
	XMLData *xmlData;

public:
	Heartbeat(XMLData *data) {
		xmlData = data;		
	}

	HANDLE bHandle;
	DWORD bID;

	static DWORD WINAPI heartBeat(LPVOID lpParameter) {
		Heartbeat *hb = (Heartbeat *)lpParameter;
		XMLData *xmlData = hb->xmlData;

		int beatSocket = socket(AF_INET, SOCK_DGRAM, 0);
		if(beatSocket == -1) {
			cout << "Error creating socket" << endl;
			return 1;
		}
		
		//cout << endl << "hearbeat to " << xmlData->hbStruct.ip.c_str() << ":" << xmlData->hbStruct.port <<endl ;
		
		struct sockaddr_in sifyAddress;
		sifyAddress.sin_family = AF_INET;
		sifyAddress.sin_port = htons(xmlData->hbStruct.port);
		sifyAddress.sin_addr.s_addr = inet_addr(xmlData->hbStruct.ip.c_str());
		memset(&(sifyAddress.sin_zero), 0, 8); 

		string sendPacketI = xmlData->macAddress + string(",") + xmlData->pvtIP + string(",") + xmlData->userID + string(",");
		//cout << endl << "sending packet: " << sendPacketI << endl;
		int hbStatus = xmlData->hbStruct.status.c_str()[0]-'0';
		while(hbStatus) {
			string sendPacket = sendPacketI + xmlData->hbStruct.status;
			
			cout << endl << "Sending beat" << endl;
			int sResult = sendtoall(beatSocket, sendPacket.c_str(), sendPacket.length(), &sifyAddress);
			if(sResult == -1) 
				cout << "SuperSify: Error sending beat" << endl;
			
			char buf[100];
			int rResult = recvfromtimeout(beatSocket, buf, 100, 4, &sifyAddress);
			if(rResult < 0) 
				cout << "SuperSify: Error receiving beat response" << endl;

			hbStatus = xmlData->hbStruct.status.c_str()[0]-'0';
			if(!hbStatus) 
				break;	
			cout << "Sleeping for " << xmlData->hbStruct.freq << " seconds" << endl;
			SleepEx(xmlData->hbStruct.freq*1000, true);			

			hbStatus = xmlData->hbStruct.status.c_str()[0]-'0';
			if(hbStatus == 1)
				xmlData->hbStruct.status = "2";			
		}
		return 0;
	}


	static int sendtoall(SOCKET sock, const char *what, int len, sockaddr_in *to) 
	{
		while(len) {		
			int n = sendto(sock, what, len, 0, (sockaddr *)to, sizeof(sockaddr_in));
			if(n == -1) return -1;
			len -= n;
			what += n;
		}
		return 0;
	}

	static int recvfromtimeout(int s, char *buf, int len, int timeout, sockaddr_in *from)
	{
		fd_set fds;
		int n;
		struct timeval tv;
		// set up the file descriptor set
		FD_ZERO(&fds);
		FD_SET(s, &fds);

		tv.tv_sec = timeout;
		tv.tv_usec = 0;
		// wait until timeout or data received
		n = select(s+1, &fds, NULL, NULL, &tv);
		if (n == 0) return -2; // timeout!
		if (n == -1) return -1; // error
		// data must be here, so do a normal recv()
		//return recv(s, buf, len, 0);
		int fromLen = sizeof(sockaddr);
		return recvfrom(s, buf, len, 0, (sockaddr *)from, &fromLen);
	}




	void startBeating() 
	{	
		bHandle = CreateThread(NULL, 0, heartBeat, this, 0, &bID);		
	}


};
