/*
Copyright (C) 2004, 2005 Brian Victor Fernandes

This file is part of SuperSify.

SuperSify is a simple console based client which you can use to log into your Sify Broadband account. 
Currently, it exists only for Win32 systems.
SuperSify is a standalone client and does not require Sify's Client to work. 

SuperSify is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with XMMS mp3cue; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

SuperSify: http://broadbandforum.in/sify/supersify
Email: infernalproteus@gmail.com
*/
// XMLData.cpp: implementation of the XMLData class.
//
//////////////////////////////////////////////////////////////////////

#include "XMLData.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
XMLData::XMLData()
{
	parser = XML_ParserCreate(NULL);
	hbStruct.status = "1";

}

XMLData::~XMLData()
{
	
}

static void XMLCALL start(void *data, const char *el, const char **attr);
static void XMLCALL end(void *data, const char *el);
static void XMLCALL characterHandler(void *userData, const XML_Char *s, int len);

void XMLData::freeParser() 
{
	XML_ParserFree(parser);
}

bool XMLData::parseData(const char *data, int length) 
{	
	XML_ParserReset(parser, NULL);
	XML_SetElementHandler(parser, start, end);
	XML_SetCharacterDataHandler(parser, characterHandler);
	XML_SetUserData(parser, this);
	int result = XML_Parse(parser, data, length, true);
	return result;
}

int Depth=0;
stack<string *> parseStack;
typedef map<string, string> DATAMAP;
DATAMAP dataMap;


static void XMLCALL start(void *data, const char *el, const char **attr)
{
 /*
  int i;
  for (i = 0; i < Depth; i++)
    cout << "  ";
  printf("Element is %s", el);
  

  for (i = 0; attr[i]; i += 2) {
    printf(" %s='%s'", attr[i], attr[i + 1]);
	//  cout << attr[i] << "=" << attr[i+1] << end;
  }
  printf("\n");*/

  parseStack.push(new string(el));
  if(!strcmpi(el, "HBS")) {
	for (int i = 0; attr[i]; i += 2) {  
		if(!strcmpi(attr[i], "ENABLE")) {
			((XMLData *)data)->hbStruct.hbEnable = (!strcmpi(attr[i+1], "Y")) ? true : false;
			break;
		}  

		else if(!strcmpi(attr[i], "serverIP"))
			((XMLData *)data)->hbStruct.ip = string(attr[i+1]);
		else if(!strcmpi(attr[i], "port"))
			((XMLData *)data)->hbStruct.port = atoi(attr[i+1]);
		else if(!strcmpi(attr[i], "Freq"))
			((XMLData *)data)->hbStruct.freq = atoi(attr[i+1]);
	}
  }
	
  else if(!strcmpi(el, "Logout")) {
	  for (int i = 0; attr[i]; i += 2)
		if(!strcmpi(attr[i], "url")) {
			((XMLData *)data)->logoutURL = string(attr[i+1]);
			break;
		}	  
  }

  else if(!strcmpi(el, "Renewals")) {
	  for (int i = 0; attr[i]; i += 2)
		if(!strcmpi(attr[i], "Flag")) {
			((XMLData *)data)->accStruct.flag = attr[i+1][0];
			break;
		}

		else if(!strcmpi(attr[i], "Message")) {
			((XMLData *)data)->accStruct.renewalMessage = string(attr[i+1]);
			break;
		}

		else if(!strcmpi(attr[i], "URL")) {
			((XMLData *)data)->accStruct.URL = string(attr[i+1]);
			break;
		}
  }
  Depth++;
}

static void XMLCALL end(void *data, const char *el)
{
  Depth--;
  parseStack.pop();
}

static void XMLCALL characterHandler(void *userData, const XML_Char *s, int len) 
{
	XMLData *xmlData = (XMLData *)userData;
	string data(s, len);
	string *top = parseStack.top();
	//cout << "Character data is " << data.data() << " for " << top->data() << endl;

//	dataMap.insert(DATAMAP::value_type("hero", data));
	//couldn't manage to get map<string, string> working - wierd.. works for <int, string> - perhaps lack of hashing function etc..
	const char *cStr = top->c_str();
	if(!strcmpi(cStr, "LoginURL"))
		xmlData->loginURL = data;
	else if(!strcmpi(cStr, "ResponseCode"))
		xmlData->responseCode = atoi(data.c_str());
	else if(!strcmpi(cStr, "ReplyMessage"))
		xmlData->replyMessage = data;
	else if(!strcmpi(cStr, "Message"))
		xmlData->message = data;
	else if(!strcmpi(cStr, "pvtIP"))
		xmlData->pvtIP = data;
	else if(!strcmpi(cStr, "samIP"))
		xmlData->samIP = data;
	else if(!strcmpi(cStr, "sessionID"))
		xmlData->sessionID = data;
	else if(!strcmpi(cStr, "Balance"))
		xmlData->accStruct.balance = data;
	else if(!strcmpi(cStr, "ProdCode"))
		xmlData->accStruct.productCode = data;
	else if(!strcmpi(cStr, "Expiry"))
		xmlData->accStruct.expiry = data;
	else if(!strcmpi(cStr, "LastLogin"))
		xmlData->accStruct.lastLogin = data;
}


